//----------------------------------------------------------------------------
//
//	Copyright (C) Microsoft Corporation 2006.  All Rights Reserved.
//
//	Project:	KEXP Now Playing
//
//	File:	    KEXPNowPlaying.js
//
//  Contains javascript code for KEXP Now Playing Live and Sidebar gadget
//
//----------------------------------------------------------------------------


var KEXPNOWPLAYING_VERSION = 1.0;
var serviceURL = "http://kexp.org/s/s.aspx";
var redirectURL = "http://kexp.org/s/r.aspx";
var updateURL = "http://randyramig.members.winisp.net/KEXPNowPlaying/KEXPNowPlaying.xml";

function debugout(str)
{
	//nowPlaying.innerText = str;
}



<!-- this script code copied from http://www-128.ibm.com/developerworks/library/j-ajax1/?ca=dgr-lnxw01Ajax -->
/*
 * Returns a function that waits for the specified XMLHttpRequest
 * to complete, then passes its XML response to the given handler function.
 * req - The XMLHttpRequest whose state is changing
 * responseXmlHandler - Function to pass the XML response to
 */
function getReadyStateHandler(req, responseXmlHandler) {

  // Return an anonymous function that listens to the 
  // XMLHttpRequest instance
  return function () {
debugout("req.readyState=" + req.readyState);
    // If the request's status is "complete"
    if (req.readyState == 4) {
debugout("req.status=" + req.status);      
      // Check that a successful server response was received
      if (req.status == 200) {

        // Pass the XML payload of the response to the 
        // handler function
        responseXmlHandler(req);

      } else {

        // An HTTP problem has occurred
        alert("HTTP error: "+req.status);
      }
    }
  }
}

function newXMLHttpRequest() {

  var xmlreq = false;

  if (window.XMLHttpRequest) {

    // Create XMLHttpRequest object in non-Microsoft browsers
    xmlreq = new XMLHttpRequest();

  } else if (window.ActiveXObject) {

    // Create XMLHttpRequest via MS ActiveX
    try {
      // Try to create XMLHttpRequest in later versions
      // of Internet Explorer

      xmlreq = new ActiveXObject("Msxml2.XMLHTTP");


    } catch (e1) {

      // Failed to create required ActiveXObject

      try {
        // Try version supported by older versions
        // of Internet Explorer

        xmlreq = new ActiveXObject("Microsoft.XMLHTTP");

      } catch (e2) {
	debugout("can't create XmlHttpRequest");
        // Unable to create an XMLHttpRequest with ActiveX
      }
    }
  }

  return xmlreq;
}

function handleResponse(response) {
 
    updateNowPlaying(nowPlaying, response.responseText, false);
	document.body.style.height = gadgetContent.offsetHeight + gadgetContent.offsetTop;
}

/*
 * Create XMLHTTP request, register handler, and send.
 */
function sendRequest(url, handler) {

  // Obtain an XMLHttpRequest instance
  var req = newXMLHttpRequest();

  // Set the handler function to receive callback notifications
  // from the request object
  var handlerFunction = getReadyStateHandler(req, handler);
  req.onreadystatechange = handlerFunction;

  debugout("Getting " + url);
  
  // Third parameter specifies request is asynchronous.
  req.open("GET", url, true);
  req.send();

}

function onCheckNowPlaying() {
	sendRequest(serviceURL + "?rand=" + Math.random(), handleResponse);
}

function init()
{
	populateGadgetContent(document.body, "KEXPLogo.gif");
	
    // Random number added to avoid proxy caching
    // Send update request
    sendRequest(updateURL + "?rand=" + Math.random(), checkForUpdate);
    
    // Send now playing request
	sendRequest(serviceURL + "?rand=" + Math.random(), handleResponse);
	
    setInterval(onCheckNowPlaying, 30000);
}


// populate all the gadget content
function populateGadgetContent(elem, strImgUrl)
{
                        
    elem.innerHTML = "<div id=gadgetContent> \
                        <img src='"+strImgUrl+"' id='kexplogo' alt='KEXP Logo'> \
                        <div id=divLinks> \
                        <a href='http://kexp.org/playlist/playlist.asp'>Full Playlist</a> <br> \
                        <a href='http://kexp.org/audio/kexp.wmx'>Listen</a><br> \
                        <a href='https://www.kexp.org/support/pledge'>Support</a> \
                        </div> \
                        <div id=nowPlaying></div> \
                        <div id=divUpdate><a href='http://randyramig.members.winisp.net/KEXPNowPlaying'>Update Available</a></div> \
                       </div>";
    elem.innerHTML += "<div id=divXmlContainer style='display:none'></div>";


}

// update the currently playing song

function updateNowPlaying(elem, strResponse, bShowLastUpdate) {

    var strNowPlaying = new String(unescape(strResponse));
    // test string
    //var strNowPlaying = new String(unescape("<k><t><p>1051065</p><s>Nothing&apos; Ever Happened</s><a>Microcastle</a><r>Deerhunter</r><l>Kranky</l><t>12:49PM</t><c>They have described themselves as &amp;#34;ambient punk,&amp;#34; though they incorporate a wide range of genres, including noise rock, art rock, ambient, and post-punk</c><b>1</b></t><s><i>1</i><t>10AM - 2PM</t><n>Variety Mix</n><d>Cheryl Waters</d><di>283</di></s><p><t>Find a bug? Tell us!</t><u>/reportaproblem.aspx</u></p></k>"));

    //
    // Currently the response from the KEXP service is not valid xml because
    // it does not contain the preproc <?xml> header.  Add that header and create
    // an XML data island to re-parse the response as XML
    //
    divXmlContainer.innerHTML = "<xml id=xmlIsland><?xml version='1.0' encoding='utf-8' ?>" + strNowPlaying + "</xml>";

    var nodeArtist = xmlIsland.XMLDocument.selectSingleNode("k/t/r");
    var nodeSong = xmlIsland.XMLDocument.selectSingleNode("k/t/s"); 
    
    if (nodeArtist && nodeSong) {
        var strArtist = nodeArtist.text;
        var strSong = nodeSong.text; 

	    elem.innerHTML = "<span id='artist'>" + strArtist + "</span><br><span id='song'>" + strSong + "</span>";

        //nowPlaying.innerHTML = "<span id='artist'>...And You Will Know Us By The Trail of The Dead</span><br><span id='song'>" + strSong + "</span>";
        if ( bShowLastUpdate )
        {
            var strLastUpdate = (new Date()).toTimeString();
            elem.innerHTML += "<br>(updated " + strLastUpdate + ")";
        }
    }
}

function checkForUpdate(response) {
    var nodeVersion = response.responseXML.selectSingleNode("KEXPNowPlaying/Released/Version");
    if (nodeVersion.text > KEXPNOWPLAYING_VERSION) {
        divUpdate.style.display = "block";
    }
	document.body.style.height = gadgetContent.offsetHeight + gadgetContent.offsetTop;
}

//
// Below is the Live.com gadget code.  Key off the existence of
// Live.com's registerNamespace function.
//
/*
if (registerNamespace)
{
    // register your Gadget's namespace
    registerNamespace("Microsoft.WindowsMobile.HomeScreen");

    // define the constructor for your Gadget (this must match the name in the manifest XML)
    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying = function(p_elSource, p_args, p_namespace)
    {
        // always call initializeBase before anything else!
	    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.initializeBase(this, arguments);
    	
	    var m_this = this;
    	
	    m_this.bShowLastUpdateTime = false;
	    m_this.msUpdateInterval    = 30000;
                                          
	    this.initialize = function(p_objScope)
	    {
	        // Call base class's initialize method
		    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.getBaseMethod(this, "initialize", "Web.Bindings.Base").call(this, p_objScope);	
           
            var strImgUrl = p_args.module.resolveUrl("KEXPLogo.gif");
            
            populateGadgetContent(p_elSource,strImgUrl);
            
            m_this.divNowPlaying = document.getElementById("nowPlaying");
            
            sendRequest();
            
            setInterval(sendRequest, m_this.msUpdateInterval);
	    }
	    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.registerBaseMethod(this, "initialize");
    	
	    this.dispose = function(p_blnUnload)
	    {
	        // Usually, you would add your dipose code here, but we have nothing to dispose for this Gadget
	        m_this.bShowLastUpdateTime = null;
	        m_this.msUpdateInterval    = null;
	        m_this.divNowPlaying       = null;
    	    
	        // always call the base object's dispose last!
	        Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.getBaseMethod(this, "dispose", "Web.Bindings.Base").call(this, p_blnUnload);
	    }
	    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.registerBaseMethod(this, "dispose");
    	
	    function onSongResponse(response)
	    {
	        //alert('onSongResponse');
	        if ( response.readyState == 4 )
	        {
	            if ( response.status == 200 )
	            {   
	                updateNowPlaying(m_this.divNowPlaying, response.responseXML.text, m_this.bShowLastUpdateTime);
	            }
	        }
	    }
    	
	    function sendRequest()
	    {
            var req = Web.Network.createRequest(
                                                Web.Network.Type.XML,
                                                "http://kexp.org/getsong.asp?rand=" + Math.random(),
                                                {proxy:"generic"}, 
                                                onSongResponse
                                                );        
                  
            req.execute(); 
	    }
    }
    Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying.registerClass("Microsoft.WindowsMobile.HomeScreen.KEXPNowPlaying", "Web.Bindings.Base");

}
*/